using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MandelbrotKliens
{
  public partial class frmBelltsok : Form
  { // Az albbi plda a 7-es gpteremhez kszlt. Amennyiben a 
    //gyakorlatot egy msik gpteremben hajtjk vgre, akkor 
    // rtelemszeren a "7-" szvegrszt mdostani kell.
    public frmBelltsok()
    { InitializeComponent();
      // Tmb ltrehozsa a nevek szmra.
      GptermiGpek = new string[15];
      // Nevek ellltsa abbl kiindulva, hogy a gpek 1-tl 15-ig 
      // sorszmozottak.
      for (int i = 1; i <= 15; i++)
      { GptermiGpek[i - 1] = "7-" + i.ToString();
      }
      // A legrdl listaablak tartalmnak trlse.
      cbGpterem.Items.Clear();
      // Nevek elhelyezse a legrdl listaablakban.
      cbGpterem.Items.AddRange(GptermiGpek);
      // Alaprtelmezs szerint az els gp a kivlasztott.
      cbGpterem.SelectedItem = cbGpterem.Items[0];
    }
    /// <summary>
    /// A gptermi gpek legrdl listaablakban megjelen gpnevek 
    /// listja.
    /// </summary>
    private string[] GptermiGpek;
    /// <summary>
		/// Belltja/lekrdezi a vals rsz als hatrrtkt.
		/// </summary>
		public double dMinRe
		{	get
			{	return double.Parse(tbMinRe.Text);
			}
			set
			{ tbMinRe.Text=value.ToString();
			}
		}
		/// <summary>
		/// Belltja/lekrdezi a vals rsz fels hatrrtkt.
		/// </summary>
		public double dMaxRe
		{	get
			{	return double.Parse(tbMaxRe.Text);
			}
			set
			{ tbMaxRe.Text=value.ToString();
			}
		}
		/// <summary>
		/// Belltja/lekrdezi a kpzetes rsz als hatrrtkt.
		/// </summary>
		public double dMinIm
		{	get
			{	return double.Parse(tbMinIm.Text);
			}
			set
			{ tbMinIm.Text=value.ToString();
			}
		}
		/// <summary>
		/// Belltja/lekrdezi a kpzetes rsz fels hatrrtkt.
		/// </summary>
		public double dMaxIm
		{	get
			{	return double.Parse(tbMaxIm.Text);
			}
			set
			{ tbMaxIm.Text=value.ToString();
			}
		}
		/// <summary>
		/// Belltja/lekrdezi az itercik maximlis megengedett rtkt.
		/// </summary>
		public int iIterMax
		{	get
			{	return int.Parse(tbIterMax.Text);
			}
			set
			{ tbIterMax.Text=value.ToString();
			}
		}
		/// <summary>
		/// Belltja/lekrdezi a webszolgltats URL-jt.
    /// Az albbi plda a 7-es gpteremhez kszlt. Amennyiben a 
    /// gyakorlatot egy msik gpteremben hajtjk vgre, akkor 
    /// rtelemszeren a "7-" szvegrszt mdostani kell.
		/// </summary>
		public string sURL
		{	get
			{	return tbURL.Text;
			}
			set
			{ string surl=value;
				// Rszekre bontjuk a sztringet. A /-jel az elvlaszt.
				// pl. http://localhost/MandelbrotSzerver/MandelbrotSzerver.asmx
				// --> "http:" "localhost" "MandelbrotSzerver" "MandelbrotSzerver" 
				string []rszek=surl.Split('/');
				// Ha kettnl kevesebb rsznk van, akkor az URL rvnytelen.
				if(rszek.Length>1)
				{ if(rszek[2]=="localhost")
						rbHelyiGp.Checked=true;
					else
						if(rszek[2].Substring(0,3)=="7-")
						{	rbGpterem.Checked=true;
							cbGpterem.SelectedItem=rszek[2];
						}
						else
						{	rbMsikGp.Checked=true;				
							tbMsikGp.Text=rszek[2];
						}
				}
				else
					throw new ApplicationException("A megadott URL rvnytelen!");
				tbURL.Text=value;
			}
		}

    /// <summary>
    /// Ha vltozik a rbHelyiGp llapota.
    /// </summary>
    private void rbHelyiGp_CheckedChanged(object sender, EventArgs e)
    {	// Ha ki van jellve.
      if (rbHelyiGp.Checked)
      {	// Rszekre bontjuk a /-jelek szerint.
        string[] rszek = tbURL.Text.Split('/');
        // Ha rszek szma kisebb mint kett, akkor az URL rvnytelen.
        if (rszek.Length > 1)
        { rszek[2] = "localhost";
          string surl = "";
          // jra sszelltjuk a teljes URL-t.
          for (int i = 0; i < rszek.Length; i++)
            surl += rszek[i] + "/";
          // Az utols /-jelet el kell tvoltani.
          tbURL.Text = surl.Substring(0, surl.Length - 1);
        }
      }
    }

    /// <summary>
    /// Ha vltozott a legrdl listaablak kivlasztott eleme.
    /// </summary>
    private void cbGpterem_SelectedIndexChanged(object sender,
      EventArgs e)
    {	// Rszekre bontjuk az URL-t a /-jelek szerint.
      string[] rszek = tbURL.Text.Split('/');
      // Ha a rszek szma kisebb kettnl az URL rvnytelen.
      if (rszek.Length > 1)
      {	// A msodik helyre betesszk a kivlasztott gp nevt.
        rszek[2] = cbGpterem.SelectedItem.ToString();
        string surl = "";
        // jbl sszelltjuk az URL-t.
        for (int i = 0; i < rszek.Length; i++)
          surl += rszek[i] + "/";
        // Az utols /-jelet el kell tvoltani.
        tbURL.Text = surl.Substring(0, surl.Length - 1);
      }
    }

    /// <summary>
    /// Ha megvltozik az rgGpterem vlasztgomb llapota.
    /// </summary>
    private void rbGpterem_CheckedChanged(object sender, EventArgs e)
    {	// A legrdl listaablakot a vlasztgomb llapotnak megfelelen
      // engedlyezzk/tiltjuk.
      cbGpterem.Enabled = rbGpterem.Checked;
      // Az esemnykezelt meghvva elidzzk, hogy a megfelel gpnv
      // jelenjen meg a tbURL mezben
      cbGpterem_SelectedIndexChanged(this, new EventArgs());
    }

    /// <summary>
		/// Ha megvltozott a tbMsikGp szerkesztmezben a szveg.
		/// </summary>
		private void tbMsikGp_TextChanged(object sender, EventArgs e)
		{	// Rszekre bontjuk az eredeti URL-t a /-jelek szerint.
			string []rszek=tbURL.Text.Split('/');	
			// Ha rszek szma kisebb mint kett, akkor az URL rvnytelen.
			if(rszek.Length>1)
			{	// Msodik rszknt beptjk a megadott gpnevet.
				rszek[2]=tbMsikGp.Text;
				// jra sszelltjuk a teljes URL-t.
				string surl="";
				for(int i=0;i<rszek.Length;i++)
					surl+=rszek[i]+"/";
				// Az utols /-jelet el kell tvoltani.
				tbURL.Text=surl.Substring(0,surl.Length-1);
			}
		}

    /// <summary>
    /// Ha megvltozott az rbMsikGp vlasztgomb llapota.
    /// </summary>
    private void rbMsikGp_CheckedChanged(object sender, EventArgs e)
    {  // A szerkesztmez engedlyezettsge a vlasztgomb bekapcsolt/
      // kikapcsolt llapottl fgg.
      if ((tbMsikGp.Enabled = rbMsikGp.Checked) == true)
      {  // Ha be van kapcsolva, akkor meghvjuk a szerkesztmez 
        // szvegvltozsi esemnykezeljt, ami ltal a tbURL
        // tartalma a megadott gpnvnek megfelelen mdosul.
        tbMsikGp_TextChanged(rbMsikGp, new System.EventArgs());
      }
    }

    /// <summary>
    /// Ellenrz esemnykezel. Ha hibs az adatbevitel, akkor a
    /// felhasznl nem lphet ki a szerkesztmezbl.
    /// </summary>
    private void tbMinRe_Validating(object sender, 
      System.ComponentModel.CancelEventArgs e)
    { try
      { // Megprbljuk vals szmm alaktani a megadott adatot.
        // Ha nem sikerl, akkor kivtel keletkezik.
        double d=double.Parse(tbMinRe.Text);
        // Ha a szm tl kicsi vagy tl nagy, akkor kivtelt idznk el.
        if(d<-2 || d>=dMaxRe)
          throw new ApplicationException("Hibs szm");  
      }
      catch
      { // Ha a megadott adat nem megfelel, akkor hibazenet, s
        // a szerkesztmezbl trtn kilps megtiltsa.
        MessageBox.Show("Az rtk a [-2,2] intervallumba kell essen, "+
          "s kisebb kell legyen mint a fels hatrrtk!",
          "Adatbeviteli hiba", MessageBoxButtons.OK, 
          MessageBoxIcon.Error);
        e.Cancel=true;  
      }
    }

    /// <summary>
    /// Ellenrz esemnykezel. Ha hibs az adatbevitel, akkor a 
    /// felhasznl nem lphet ki a szerkesztmezbl.
    /// </summary>
    private void tbMaxRe_Validating(object sender, 
      System.ComponentModel.CancelEventArgs e)
    { try
      { // Megprbljuk vals szmm alaktani a megadott adatot.
        // Ha nem sikerl, akkor kivtel keletkezik.
        double d=double.Parse(tbMaxRe.Text);
        // Ha a szm tl kicsi vagy tl nagy, akkor kivtelt idznk el.
        if(d>2 || d<=dMinRe)
          throw new ApplicationException("Hibs szm");  
      }
      catch
      { // Ha a megadott adat nem megfelel, akkor hibazenet, s
        // a szerkesztmezbl trtn kilps megtiltsa.
        MessageBox.Show("Az rtk a [-2,2] intervallumba kell essen, "+
          "s nagyobb kell legyen mint az als hatrrtk!",
          "Adatbeviteli hiba", MessageBoxButtons.OK, 
          MessageBoxIcon.Error);
        e.Cancel=true;  
      }
    }

    /// <summary>
    /// Ellenrz esemnykezel. Ha hibs az adatbevitel, akkor a
    /// felhasznl nem lphet ki a szerkesztmezbl.
    /// </summary>
    private void tbMinIm_Validating(object sender, 
      System.ComponentModel.CancelEventArgs e)
    { try
      { // Megprbljuk vals szmm alaktani a megadott adatot.
        // Ha nem sikerl, akkor kivtel keletkezik.
        double d=double.Parse(tbMinIm.Text);
        // Ha a szm tl kicsi vagy tl nagy, akkor kivtelt idznk el.
        if(d<-2 || d>=dMaxIm)
          throw new ApplicationException("Hibs szm");  
      }
      catch
      { // Ha a megadott adat nem megfelel, akkor hibazenet, s
        // a szerkesztmezbl trtn kilps megtiltsa.
        MessageBox.Show("Az rtk a [-2,2] intervallumba kell essen, "+
          "s kisebb kell legyen mint a fels hatrrtk!",
          "Adatbeviteli hiba", MessageBoxButtons.OK, 
          MessageBoxIcon.Error);
        e.Cancel=true;  
      }
    }

    /// <summary>
    /// Ellenrz esemnykezel. Ha hibs az adatbevitel, akkor a
    /// felhasznl nem lphet ki a szerkesztmezbl.
    /// </summary>
    private void tbMaxIm_Validating(object sender, 
      System.ComponentModel.CancelEventArgs e)
    { try
      { // Megprbljuk vals szmm alaktani a megadott adatot.
        // Ha nem sikerl, akkor kivtel keletkezik.
        double d=double.Parse(tbMaxIm.Text);
        // Ha a szm tl kicsi vagy tl nagy, akkor kivtelt idznk el.
        if(d>2 || d<=dMinIm)
          throw new ApplicationException("Hibs szm");  
      }
      catch
      { // Ha a megadott adat nem megfelel, akkor hibazenet, s
        // a szerkesztmezbl trtn kilps megtiltsa.
        MessageBox.Show("Az rtk a [-2,2] intervallumba kell essen, "+
          "s nagyobb kell legyen mint az als hatrrtk!",
          "Adatbeviteli hiba", MessageBoxButtons.OK, 
          MessageBoxIcon.Error);
        e.Cancel=true;  
      }  
    }

    /// <summary>
    /// Ellenrz esemnykezel. Ha hibs az adatbevitel, akkor a 
    /// felhasznl nem lphet ki a szerkesztmezbl.
    /// </summary>
    private void tbIterMax_Validating(object sender, 
      System.ComponentModel.CancelEventArgs e)
    { try
      { // Megprbljuk eljel nlkli egsz szmm alaktani a megadott 
        // adatot. Ha nem sikerl, akkor kivtel keletkezik.
        uint u=uint.Parse(tbIterMax.Text);
        // Ha a szm tl kicsi, akkor kivtelt idznk el.
        if(u<1)
          throw new ApplicationException("Hibs szm");  
      }
      catch
      { // Ha a megadott adat nem megfelel, akkor hibazenet, s
        // a szerkesztmezbl trtn kilps megtiltsa.
        MessageBox.Show("Az itercik maximlisan megengedett "+ 
          "szmnl megadott "+
          "rtk nem egy pozitv egsz szm!",
          "Adatbeviteli hiba", MessageBoxButtons.OK, 
          MessageBoxIcon.Error);
        e.Cancel=true;  
      }
    }
  

  }
}